Mid-level React Interview

Поделиться
HTML-код
  • Опубликовано: 20 сен 2024
  • I do a mock interview with a developer at work, Cody. He crushes it!
    Join our Front End Guild Discord server: / discord
    We built a platform to guarantee your resume gets seen by a human: hackerrelay.com

Комментарии • 104

  • @FilhoLouco
    @FilhoLouco 11 дней назад +2

    Technical Questions and Answers
    React Fundamentals:
    State vs. Context: Explained the difference between state and context in React.
    State Updates: Discussed how to trigger state changes in parent components from child components.
    Redux: Shared thoughts on Redux and its boilerplate nature.
    Component Passing: Explained how to pass components as props to other components.
    Coding Exercise:
    Longest Substring.

  • @Kreshel1
    @Kreshel1 Год назад +46

    react interview... 2 react questions and then 90% of the video a leet code exercise

    • @davronmaxmudov3972
      @davronmaxmudov3972 5 месяцев назад +4

      Thanks 😊, you save me 40 minutes)

    • @RealParadox85
      @RealParadox85 2 месяца назад +1

      the type of BS they use in react interviews these days, stupidly enough 😂

  • @licokr
    @licokr 11 месяцев назад +12

    As a person who preparing for frontend interviews, it really helped. Many people talk about the question because the question may seem like focused on algorithm. I don't know if this is the best interview for the md-level "react" interview though, the point is that. This video is really helpful for me. I really appreciate it you made this video and uploaded it on youtube. Thank you very much! I'm looking forward to further mock interview videos!

  • @michaelyabut5969
    @michaelyabut5969 Год назад +73

    Pretty easy to do it faster than n^2 at home, but I would probably freeze up in an interview lol. I could feel that guys anxiety haha

    • @michaelyabut5969
      @michaelyabut5969 Год назад +5

      Oh just saw the end that it's 2n not n^2 TIL

    • @lowestCommonDenominator
      @lowestCommonDenominator Год назад +16

      same, i had an optimal solution in my head immediately but in an interview setting i'm pretty sure i'd forget what javascript even was

    • @wlgs
      @wlgs Год назад +9

      its n^2, subStr.includes(currentChar) is kinda innocent but it's O(n), better to use set/hash map here

    • @MocBocUS
      @MocBocUS Год назад +1

      @@wlgs my solution is just loop through the string once and keep track of the longest string and current string so it still be O(n)

  • @mooosafir74
    @mooosafir74 Год назад +10

    I like the concept of structuring the interview , very scientific.

  • @devzozo
    @devzozo 6 месяцев назад +2

    I think a good way to practice would be to copy a hackerrank problems into a react app, display the result(s) in a component, then make an input for the user to see different results from whatever the hackerrank question is asking to do. That seems to be the theme for many of the early-mid level questions. Cody kept saying something along the lines of "Theres probably a better way to do this" and I think that's ok to say, but if you say it too frequently, it makes you seem less confident or qualified. You might want to reword it in a more 'impressive' way by saying something like "I would probably review the documentation to make sure this is the best way to do this...".

  • @AAmorim1989
    @AAmorim1989 8 месяцев назад +7

    - He did not crush it, he would have been rejected.
    - This is not a mid level interview, more like an entry level one.

    • @justinmlawrence
      @justinmlawrence  8 месяцев назад +2

      Great feedback!

    • @cy3889
      @cy3889 5 месяцев назад +2

      i had the same feeling, he didn't answer the basic technical questions at the start. Feels more like junior level

  • @ahmedAltariqi
    @ahmedAltariqi 11 месяцев назад +4

    I remember watching this video when it was released and I didn't understand anything at all. Now, I solved it without watching the video and I feel really happy! 😂

    • @justinmlawrence
      @justinmlawrence  11 месяцев назад

      Awesome! 👏🏻👏🏻👏🏻

    • @ahmedAltariqi
      @ahmedAltariqi 11 месяцев назад

      Thanks!
      Any feedback from you is much appreciated!
      function getLongestNonRepeatingSubstring(str) {
      let currentSubstring = "";
      let longestSubstring = "";
      for (let char of str) {
      if (currentSubstring.includes(char)) {
      currentSubstring = "";
      }
      currentSubstring += char;
      if (longestSubstring.length < currentSubstring.length) {
      longestSubstring = currentSubstring;
      }
      }
      return longestSubstring;
      }

  • @khalidben9940
    @khalidben9940 9 месяцев назад +3

    The use of Array.includes method will affect the time complexity that will be O(n^2), nested loop so to speak.

  • @mahmednabil2429
    @mahmednabil2429 Год назад +9

    ahh.. btw the solution that they agreed on is not correct, consider "ABCDAFG", their code will output "ABCD" but the correct answer is "BCDAFG".
    also this is an easy two-pointers problem.

    • @alexyan125
      @alexyan125 Год назад

      Coz the loop starts from first character and only went one time.

  • @ilichpadilla2448
    @ilichpadilla2448 Год назад +4

    Do more Interviews like this one. Really helpful video. Keep it

  • @horne1395
    @horne1395 Год назад +7

    My first thought about the first problem is to have a way to know which characters has already been iterated to. Maybe something like a Set or a Map, array could definitely be used but that would be O(n). then whenever the current iterated character is already in the set or map, that means we have to reset the tracker.

    • @guilhermecruz
      @guilhermecruz Год назад +2

      yeah, Set would be a better choice performance wise

    • @bennetleff4088
      @bennetleff4088 Год назад +4

      the trick is sliding window

    • @ASAPKep
      @ASAPKep 10 месяцев назад

      I would assume either way the worst case would be O(n) because you still have to iterate through the whole string character by character to append to your map. The implementation here was O(n+n) or O(2n) which is still equivalent to O(n) as the worst case.

  • @krishnagupta31
    @krishnagupta31 Год назад +4

    In that getTheLargestSubString problem, u can probably use 'continue' to just skip that repeating char that u don't want in ur array

  • @Faith_L3S5-ZERO
    @Faith_L3S5-ZERO Год назад +6

    i won't lie, i did not expect the materials for mid-level position interview would be like this; i understand and can kind of solve the problem by myself which was surprising
    i always thought that i am more of a junior position guy despite having more than 1.5 yoe because i am never get confident enough of my skills.. but then maybe that's why i am still not good enough for a mid-senior level because i'm still not confident?
    no telling honestly lol

    • @quochoangang6014
      @quochoangang6014 Год назад +2

      Same. I'm never get confident enough of my skills too.

    • @wykydytron
      @wykydytron Год назад +2

      It's what happens to most self thought programmers, because we don't have grades given by teachers and often no one to compare too we think we are still not good. Reality is we very well may be overqualified for junior position but are held back by simple lack of experience and by extention lack of confidence. Then there is whole interview stress thing we're i know fir a fact outspoken confident but weak programmers do better then timid shy but very good programmers it's just how it is, so it's important that interviewer is experienced enough to catch wats going on.

  • @duyanhcenland2044
    @duyanhcenland2044 11 месяцев назад +4

    as a self taugh i feel that its hard to organize what you need to know to get a job

  • @SuperYoda7
    @SuperYoda7 Год назад +24

    in reality we would use chatGPT for that function and then just build the component.

  • @preslavgetov1330
    @preslavgetov1330 8 месяцев назад +2

    I would just add (based on my interview experience) that perhaps stating that you have never touched something or don't know it (in the redux/jotai question) does not really add anything to conversation other then name drop. If you don't have any knowledge to share, a simple don't know about it would suffice.

  • @gombosmm
    @gombosmm Год назад +10

    Would this not be a junior/entry interview...? I am on that level, and I feel like I could've done exactly the same

  • @PatrykBiegański-f5v
    @PatrykBiegański-f5v Год назад +3

    Man, I'm struggling to get entry/junior level job and could answer those questions anytime.

  • @StivenBallshi
    @StivenBallshi 8 месяцев назад +2

    The solution to this is wrong tho.
    If we had another string for example
    str = 'ABCDAEFGH' - the longest string here is 'BCDAEFGH'.
    The solution cody provided wouldn't work , so you need to check with either the substring method or charAt because you need to see if one of the characters is repeated.

  • @kashmyr8
    @kashmyr8 5 месяцев назад +1

    Nice video but I think the candidate overall would have failed in my book.
    1. They answered all the React questions in the beginning pretty well.
    2. The solution for the coding challenge is pretty much O(n^2) due to the includes nested in the for loop. The solution is not optimal and a pretty messy.
    3. The react code was messy. The util method should have been brought in from another file instead of residing in the component. The util function itself should have been "pure" and should not include any React state setter methods. That should be done outside of the util method.
    Not knocking the interviewee at all though, it's a lot harder under pressure obviously.

  • @nr7343
    @nr7343 Год назад +4

    He did not complete the exercise. maxLength=currentVal

  • @pkorneev5226
    @pkorneev5226 2 месяца назад

    me personally would not even call him a junior at this point, but pretty good interview, questions at the start were more like an internship level max

  • @berndeveloper
    @berndeveloper Год назад +4

    I really don't like that much this kind of interviews, because in real life you have an entire world to explore different approaches to hit the best solution. It feels more stressful than a real scenario, if you ask me. Good questions though. (As feedback: Next time don't use music, most of us are listening our own music)

  • @mahdijafaree5332
    @mahdijafaree5332 10 месяцев назад +1

    guys take it easy, as he said it is a MOCK interview haha

  • @Madion86
    @Madion86 Год назад +3

    Your solution fails on a string 'ABCDAEFGHI'. Your solution answer = 'AEFGHI', correct answer = 'BCDAEFGHI'. Sorry, but dividing by chunks isnt always enough to solve this problem; so your algorithm is wrong from its idea.

  • @barboradolejsova3502
    @barboradolejsova3502 Месяц назад

    The music is a little bit distracting and making hard to understand sometimes. :( Othewise awesome job!

  • @divakarluffy3773
    @divakarluffy3773 Год назад +8

    Nice one! hope my interviewer was this kind 😂

    • @rl6382
      @rl6382 Год назад

      Well was he?

  • @andrewwall2730
    @andrewwall2730 9 месяцев назад +2

    Not sure I understand how the algorithm challenge has anything to do with react. Seems 90% of time not about react. And the code challenge was not well explained. Thought any consecutive same chars should have been eliminated in the results, but guess I was wrong.

  • @SeRoShadow
    @SeRoShadow 10 месяцев назад +2

    Now seriously though, is this interview even junior level.
    I mean I figured in the first 10s that you should create an array to add chunks then sort it by length.
    And despite this, when I apply for a position, I dont even get an interview call, not even for an unpaid internship position.
    It makes me feel bad since I self-studied React 2 Yrs.
    My portoflio is still in building phase, but the ideas I try to execute require extensive development (Job Platform, Company Portal, ECommerce Everything)
    Should I copy porfolio projects and then rewrite them as my own (while still working on my own projects) , just to get to the interview ?

  • @yuliasereda5671
    @yuliasereda5671 7 месяцев назад +1

    I was wondering about your question smth llike what we get if we pass the component to another component. so, can be the answer that we will get a HOC(high order component) which get and return a component. if we use TS, so we can describe it like React.NodeChild. i'm a junior, so don't judge me please. but can it be the answer?

  • @thinhbui4090
    @thinhbui4090 Год назад +1

    thanks i really need this

  • @mycraplife
    @mycraplife Год назад +11

    Terrible React interview. It was an algorithms interview, which he will never need to use.

    • @cod-the-creator
      @cod-the-creator Год назад +4

      No joke, the real life correct answer is "dude, Gary, this API is whack, why are you giving me a bunch of bullshit instead of the thing I need?"

    • @maiaklimenko6614
      @maiaklimenko6614 5 месяцев назад

      At least it's close to a real interview. Everyone asks questions about data structure

  • @user-zv6bv7eu8k
    @user-zv6bv7eu8k 11 месяцев назад +1

    so lost as to how the function knows what the new maxLength is????

  • @JS_Skyline
    @JS_Skyline Год назад +5

    Instead of using second loop you could use sort method to sort the array from biggest to lowest(arr.sort((a,b) => a.length < b.length ? 1 : -1)) and then return the first element of the array

    • @nr7343
      @nr7343 Год назад +4

      Sort? Second loop its better bc time complexty Mr russain

    • @Reubzzzzz
      @Reubzzzzz Год назад +4

      Why need to sort the elements when you can just take their length and compare that. Its faster that way!

    • @lets_see_777
      @lets_see_777 Год назад +1

      wow you went O(n) to On(logn) complexity and think its better

  • @idanatiya3925
    @idanatiya3925 Год назад +1

    The interviewer looks like Doctor who

  • @skdtackkskdtackk
    @skdtackkskdtackk 2 месяца назад

    Have you a version without background music?

  • @richardramirez5746
    @richardramirez5746 Год назад +1

    Great video, is there anyway to try this with you?

    • @justinmlawrence
      @justinmlawrence  Год назад

      Yeah! Just reach out on our Discord. Always looking for new people! 👍🏻
      discord.gg/rFP29feQ

  • @anasouardini
    @anasouardini Год назад +2

    "Mid-level" is kind of meaningless in this exact interview.

  • @techmoo5595
    @techmoo5595 Год назад +1

    Often, one's posture when sitting can reveal their level of expertise or competence.

  • @sadique_x_
    @sadique_x_ 9 месяцев назад +1

    chale i no reach!

  • @21mighty86
    @21mighty86 Год назад +4

    3:56 no, correct answer is callbacks

    • @techaddictdude
      @techaddictdude Год назад

      Which question?

    • @21mighty86
      @21mighty86 Год назад

      Prop drilling state setter does not fit to react flow of data, and it can cause bugs

  • @Netai19906
    @Netai19906 3 месяца назад

    great content but the music is not helpful

  • @mahmednabil2429
    @mahmednabil2429 Год назад +1

    also the real complexity is more than n^2, you should consider the usage of string "+=" operator is O(N) itself

  • @369-davian
    @369-davian 7 месяцев назад

    having a b2 level of english, will be deat on the tree first minute 🤮

  • @foqsi_
    @foqsi_ 11 месяцев назад +1

    Cool video, but so difficult for me to listen to people say "uh" or "um" every other word. haha

  • @JS_Skyline
    @JS_Skyline Год назад +5

    bthw in Russia this is definitely not a mid-level it’s more like junior or even intern level of knowledge

    • @prompt9416
      @prompt9416 Год назад

      bruhh

    • @Adidobro
      @Adidobro Год назад +7

      yeah new born baby level, rotting in trench soldier level, what else?

    • @mikejones8519
      @mikejones8519 Год назад +7

      In Soviet Ruzzia, code write you!

  • @neok8902
    @neok8902 3 месяца назад

    bullshit interview

  • @amy_lio
    @amy_lio Год назад +3

    Probably smth like that
    // 'ABCDDDHIGKL'
    function longestUniqueSeq(str: string) {
    let maxStr = "";
    let bestMaxStr = "";
    for (const ch of str) {
    if (maxStr.includes(ch)) {
    bestMaxStr = withMaxLength(bestMaxStr, maxStr);
    maxStr = ch;
    continue;
    }
    maxStr += ch;
    }
    return withMaxLength(bestMaxStr, maxStr);
    }
    function withMaxLength(str1: string, str2: string) {
    return str1.length > str2.length ? str1 : str2;
    }

  • @gooseob
    @gooseob 4 месяца назад +3

    interesting interview!
    I have a short solution to the algorithm question
    ```js
    const longestNonRepeatingSequence = (str) =>
    str
    .match(/.*?(.)(?=\1|$)/g)
    .reduce((acc, item) => (item.length > acc.length ? item : acc), "");
    ```

  • @BraedenSmith
    @BraedenSmith Год назад +3

    FWIW: Big O on this solution 100% O(n^2) because of the `.includes`.

  • @JadesFitnessBucketList
    @JadesFitnessBucketList 5 месяцев назад

    really loved watching this, i kept pausing after the question to quickly think about what i would say and how I would write the function before Cody answered. My solution was super similar apart from i used **continue ** in my if block in the loop and at the end to find the longest str in the array i did: return strArr.reduce((longest, current) => {
    return current.length > longest.length ? current : longest;
    }, ' ');

  • @anasouardini
    @anasouardini Год назад +1

    How is my clever (I guess) solution?
    #!/bin/env node
    let longestChunckIndexPair = [0, 0];
    let firstIndex = [];
    const setIfLongest = (lastIndex)=>{
    if((lastIndex - firstIndex) > (longestChunckIndexPair[1] - longestChunckIndexPair[0])){
    longestChunckIndexPair = [firstIndex, lastIndex];
    }
    }
    const func = (inputStr)=>{
    // O(n-1)
    for(let i=0; i

  • @ondrejvrto
    @ondrejvrto 8 месяцев назад +1

    My preety solution with reducer. .... Changing the condition to "actualChar === result[0][0]" gives you the second version.
    const longestUniqueSequention = (str) => {
    return [...str]
    .reduce((result, actualChar) => {
    actualChar a.length < b.length)
    .at(0)
    .reverse()
    .join('');
    }
    console.log(longestUniqueSequention('ABCDDDDEFGHI')); //

  • @DevMe-f5v
    @DevMe-f5v 16 дней назад

    another way
    function getIterateData(str, list) {
    let filterChar = list ?? "ABCDDDEFGHI";
    let filterStr = Array.from(filterChar.split(" ")[0]);
    let pos = filterChar.indexOf(str) + str.length;
    let strVal = [];
    let center = Math.floor((filterChar.length - 1) / 2);
    let uniqueValue;
    if (pos

  • @elvado1014
    @elvado1014 Год назад +2

    const getStr = (s) => {
    let startSlice = 0;
    let longestUniqString = " ";
    const compareAndSetString = (endSlice) => {
    const newSting = s.slice(startSlice, endSlice);
    if (longestUniqString?.length < newSting.length) {
    longestUniqString = newSting;
    }
    };
    for (let i = 0; i < s.length; i++) {
    const currentLetter = s[i];
    const nextIndex = i + 1;
    const nextLetter = s[nextIndex];
    if (currentLetter === nextLetter) {
    compareAndSetString(nextIndex);
    startSlice = nextIndex;
    }
    compareAndSetString(nextIndex);
    }
    return longestUniqString;
    }

  • @user-ex3nu5ix6h
    @user-ex3nu5ix6h 11 месяцев назад +2

    const getLongest = (str) => {
    var currStr = "";
    var tempStr = "";
    for(let i = 0; i < str.length; i++){
    if( str[i + 1] && (str[i] != str[i + 1])){
    tempStr += str[i];
    }else{
    if(tempStr.length + 1 > currStr.length){
    currStr = tempStr + str[i];
    tempStr = "";
    }
    }
    }
    return currStr;
    }

  • @DevMe-f5v
    @DevMe-f5v 16 дней назад

    this my solution
    function getNoNRepeatedLongChar(str, list) {
    let filterChar = list ?? "ABCDDDEFGHI";
    let pos = filterChar.indexOf(str) + str.length;
    let center = Math.floor((filterChar.length - 1) / 2);
    let uniqueValue;
    if (pos

  • @cagataykaban7592
    @cagataykaban7592 3 месяца назад +1

    const getLongestNonRepeatingSubstring = (s) => {
    let result = ""
    for (let i = 0; i < s.length; i++) {
    let char = s[i];
    let newString = s.substring(0, i)
    if (!newString.includes(char)) {
    result += char
    }
    }
    return result
    }